 /*--------------------------------------------------
 * POV-Display
 * 5x5 Pixel Zeichen
 * Version 1.0 vom 18.06.2018
 * Attraktor e.V.
 */
 
#include <ESP8266WiFi.h>

double delayTime = 3.0; //these value may change acc. to the length of the word in the POV display //default: 2.2 //vorher: 2.0
double charBreak = 4.0; //these value may change acc. to the length of the word in the POV display //default: 5.5 //vorher: 2.1
double stringBreak = 120.0; //these value may change acc. to the length of the word in the POV display //default: 120

int LED1 = 5;  //D1
int LED2 = 4;  //D2
int LED3 = 14; //D5
int LED4 = 12; //D6
int LED5 = 13; //D7

/*--------------------------------------------------
HTTP 1.1 Webserver as AccessPoint for ESP8266 
for ESP8266 adapted Arduino IDE

Does HTTP 1.1 with defined connection closing.
Handles empty requests in a defined manner.
Handle requests for non-exisiting pages correctly.
--------------------------------------------------*/

const String sVersion = "Version 1.0";
const String sVersionDate = "18.06.2018";

const char* ssid = "POV-Display-"; // der erste Teil des Namens des WIFI Access Points
const char* password = ""; // set to "" for open access point w/o passwortd
unsigned long ulReqcount;

WiFiServer server(80); // Eine Instanz auf dem Server für Port 80 erzeugen

//char* sAnzeigetext = "#"; // POV Text auf Karo setzen
char* sAnzeigetext = "otto"; // POV Text setzen

// Zeichen generieren
int a[] = {1, 6, 26, 6, 1};
int b[] = {31, 21, 21, 10, 0};
int c[] = {14, 17, 17, 10, 0};
int d[] = {31, 17, 17, 14, 0};
int e[] = {31, 21, 21, 17, 0};
int f[] = {31, 20, 20, 16, 0};
int g[] = {14, 17, 19, 10, 0};
int h[] = {31, 4, 4, 4, 31};
int i[] = {0, 17, 31, 17, 0};
int j[] = {0, 17, 30, 16, 0};
int k[] = {31, 4, 10, 17, 0};
int l[] = {31, 1, 1, 1, 0};
int m[] = {31, 12, 3, 12, 31};
int n[] = {31, 12, 3, 31, 0};
int o[] = {14, 17, 17, 14, 0};
int p[] = {31, 20, 20, 8, 0};
int q[] = {14, 17, 19, 14, 2};
int r[] = {31, 20, 22, 9, 0};
int s[] = {8, 21, 21, 2, 0};
int t[] = {16, 16, 31, 16, 16};
int u[] = {30, 1, 1, 30, 0};
int v[] = {24, 6, 1, 6, 24};
int w[] = {28, 3, 12, 3, 28};
int x[] = {17, 10, 4, 10, 17};
int y[] = {17, 10, 4, 8, 16};
int z[] = {19, 21, 21, 25, 0};

int spc[] = {0, 0, 0, 0, 0};
int eos[] = {0, 1, 0, 0, 0};
int excl[] = {0, 29, 0, 0, 0};
int ques[] = {8, 19, 20, 8, 0};
int karo[] = {4,14,31,14,4};
int plus[] = {4,4,31,4,4};

void displayLine(int line){
  int myline;
  myline = line;
  if (myline>=16) {digitalWrite(LED1, HIGH); myline-=16;} else {digitalWrite(LED1, LOW);}
  if (myline>=8)  {digitalWrite(LED2, HIGH); myline-=8;}  else {digitalWrite(LED2, LOW);}
  if (myline>=4)  {digitalWrite(LED3, HIGH); myline-=4;}  else {digitalWrite(LED3, LOW);}
  if (myline>=2)  {digitalWrite(LED4, HIGH); myline-=2;}  else {digitalWrite(LED4, LOW);}
  if (myline>=1)  {digitalWrite(LED5, HIGH); myline-=1;}  else {digitalWrite(LED5, LOW);}
}

void displayChar(char ch){
  if ((ch == 'a') or (ch == 'A')){for (int i = 0; i <5; i++){displayLine(a[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'b') or (ch == 'B')){for (int i = 0; i <5; i++){displayLine(b[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'c') or (ch == 'C')){for (int i = 0; i <5; i++){displayLine(c[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'd') or (ch == 'D')){for (int i = 0; i <5; i++){displayLine(d[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'e') or (ch == 'E')){for (int i = 0; i <5; i++){displayLine(e[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'f') or (ch == 'F')){for (int i = 0; i <5; i++){displayLine(f[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'g') or (ch == 'G')){for (int i = 0; i <5; i++){displayLine(g[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'h') or (ch == 'H')){for (int i = 0; i <5; i++){displayLine(h[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'i') or (ch == 'I')){for (int it = 0; it <5; it++){displayLine(i[it]);delay(delayTime);}displayLine(0);}
  if ((ch == 'j') or (ch == 'J')){for (int i = 0; i <5; i++){displayLine(j[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'k') or (ch == 'K')){for (int i = 0; i <5; i++){displayLine(k[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'l') or (ch == 'L')){for (int i = 0; i <5; i++){displayLine(l[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'm') or (ch == 'M')){for (int i = 0; i <5; i++){displayLine(m[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'n') or (ch == 'N')){for (int i = 0; i <5; i++){displayLine(n[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'o') or (ch == 'O')){for (int i = 0; i <5; i++){displayLine(o[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'p') or (ch == 'P')){for (int i = 0; i <5; i++){displayLine(p[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'q') or (ch == 'Q')){for (int i = 0; i <5; i++){displayLine(q[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'r') or (ch == 'R')){for (int i = 0; i <5; i++){displayLine(r[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 's') or (ch == 'S')){for (int i = 0; i <5; i++){displayLine(s[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 't') or (ch == 'T')){for (int i = 0; i <5; i++){displayLine(t[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'u') or (ch == 'U')){for (int i = 0; i <5; i++){displayLine(u[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'v') or (ch == 'V')){for (int i = 0; i <5; i++){displayLine(v[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'w') or (ch == 'W')){for (int i = 0; i <5; i++){displayLine(w[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'x') or (ch == 'X')){for (int i = 0; i <5; i++){displayLine(x[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'y') or (ch == 'Y')){for (int i = 0; i <5; i++){displayLine(y[i]);delay(delayTime);}displayLine(0);}
  if ((ch == 'z') or (ch == 'Z')){for (int i = 0; i <5; i++){displayLine(z[i]);delay(delayTime);}displayLine(0);}
  if (ch == '!'){for (int i = 0; i <5; i++){displayLine(excl[i]);delay(delayTime);}displayLine(0);}
  if (ch == '?'){for (int i = 0; i <5; i++){displayLine(ques[i]);delay(delayTime);}displayLine(0);}
  if (ch == '.'){for (int i = 0; i <5; i++){displayLine(eos[i]);delay(delayTime);}displayLine(0);}
  if (ch == '#'){for (int i = 0; i <5; i++){displayLine(karo[i]);delay(delayTime);}displayLine(0);}
  if (ch == ' '){for (int i = 0; i <5; i++){displayLine(spc[i]);delay(delayTime);}displayLine(0);}
  if (ch == '+'){for (int i = 0; i <5; i++){displayLine(plus[i]);delay(delayTime);}displayLine(0);}
  delay(charBreak);
}

void displayString(char* s){
  for (unsigned int i = 0; i<=strlen(s); i++){
    displayChar(s[i]);
  }
  delay(stringBreak);
}

/* Nur zum Test
void displayString2(char* s){
  for (unsigned int i = 0; i<=strlen(s); i++){
    displayChar(s[i]);
  }
  delay(3);
  for (unsigned int i = strlen(s); i>=0; i--){
    displayChar(s[i]);
  }
}
*/

void setup(){
  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);
  pinMode(LED3, OUTPUT);
  pinMode(LED4, OUTPUT);
  pinMode(LED5, OUTPUT);

// setup globals
  ulReqcount=0;

  Serial.begin(9600); // Serielle Verbindung initialisieren
  WiFi.mode(WIFI_AP); // WIFI Access Point Modus initialisieren

  Serial.println("");
  Serial.println("POV Lauflicht " + String(sVersion) + " vom " + String(sVersionDate) + " Attraktor e.V.");
  Serial.println("");


// Das Anhängsel für den Access Point Namen (SSID) aus der MAC ID des ESP Moduls generieren.
// Um den Namen nicht zu lang werden zu lassen, werden hier nur die letzten 2 Bytes verwendet.
// Der Aufwand dient dazu, um einen möglichst einmaligen Access Point Namen für das jeweils verwendete ESP Modul entstehen zu lassen.
  uint8_t mac[WL_MAC_ADDR_LENGTH];
  WiFi.softAPmacAddress(mac);
  String macID = String((mac[WL_MAC_ADDR_LENGTH - 2] * 256 + mac[WL_MAC_ADDR_LENGTH - 1]), DEC);
  macID.toUpperCase();
  String AP_NameString = ssid + macID;
  char AP_NameChar[AP_NameString.length() + 1];
  memset(AP_NameChar, 0, AP_NameString.length() + 1);
  for (uint i = 0; i < AP_NameString.length(); i++) AP_NameChar[i] = AP_NameString.charAt(i);

  // WIFI Access Point und den Web Server starten
  WiFi.softAP(AP_NameChar, password);
  server.begin();
  Serial.print("WIFI Access Point gestartet. Name (SSID) : "); Serial.println(AP_NameChar);
  Serial.print("WEB-Server erreichbar unter der IP-Adresse): "); Serial.println(WiFi.softAPIP());
  Serial.println("");
}
  
void loop()
{
// LEDs ansteuern
  displayString(sAnzeigetext);
// WIFI Client handling
  WiFiClient client = server.available(); // Prüfen ob ein WIFI-Client verbunden ist
  if (!client) {
    //Serial.println("no client request");
    return; // Wenn kein CLient verbunden ist, wieder zum Anfang. Also warten bis der WIFI-Client Daten gesendet hat.
  }
  Serial.println("Neuer WIFI-Client"); // Jetzt ist ein Client verbunden ...
  unsigned long ultimeout = millis() + 250;
  while (!client.available() && (millis() < ultimeout)) {
    delay(1);
  }
  if (millis() > ultimeout) {
    Serial.println("WIFI-Client Fehler: Connection-Time-Out!");
    return;
  }

  String sRequest = client.readStringUntil('\r'); // Die Erste Zeile der Anfrage lesen
  client.flush();

  if (sRequest == "") { // WIFI-Client stoppen, wenn die Anfrage leer ist
    Serial.println("WIFI-Client Fehler: Leere Anfrage! -> WIFI-Client angehalten");
    client.stop();
    return;
  }

// "get path"; Das Ende des Pfads ist entweder ein " " oder ein "?" (Syntax z.B. GET /?pin=SENSOR_A HTTP/1.1)
  String sPath = "", sParam = "", sCmd = "";
  String sGetstart = "GET ";
  int iStart, iEndSpace, iEndQuest;
  iStart = sRequest.indexOf(sGetstart);
  if (iStart >= 0) {
    iStart += +sGetstart.length();
    iEndSpace = sRequest.indexOf(" ", iStart);
    iEndQuest = sRequest.indexOf("?", iStart);
	
	// Sind Parameter vorhanden?
    if (iEndSpace > 0) { // Den Pfad und die Parameter isolieren
      if (iEndQuest > 0) { // Pfad und Parameter
        sPath = sRequest.substring(iStart, iEndQuest);
        sParam = sRequest.substring(iEndQuest, iEndSpace);
      }
      else { // Pfad aber keine Parameter
        sPath = sRequest.substring(iStart, iEndSpace);
      }
    }
  }
  
// Den Befehl isolieren und auf der seriellen Schnittstelle ausgeben
  if (sParam.length() > 0) {
    int iEqu = sParam.indexOf("=");
    if (iEqu >= 0) {
      sCmd = sParam.substring(iEqu + 1, sParam.length());
      Serial.println(sCmd);
    }
  }

// Die HTML Seite erzeugen
  String sResponse, sHeader;
  if (sPath != "/") { // Für unpassenden Pfad eine 404-Fehlerseite generieren
    sResponse = "<html><head><title>404 Not Found</title></head><body><h1>Not Found</h1><p>Die angeforderte Webseite (URL) gibt es auf diesem Server nicht.</p></body></html>";
    sHeader = "HTTP/1.1 404 Not found\r\n";
    sHeader += "Content-Length: ";
    sHeader += sResponse.length();
    sHeader += "\r\n Content-Type: text/html\r\n Connection: close\r\n\r\n";
  }
  else { // Für passenden Pfad ...
    ulReqcount++;
    sResponse  = "<html><head><title>POV-Light</title></head><body>";
  	sResponse += "</title></head><body>";
    sResponse += "<font color=\"#000000\"><body bgcolor=\"#81BEF7\">";
    sResponse += "<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, user-scalable=yes\">";
	  sResponse += "<h1>POV Lauflicht</h1>";
    sResponse += "<FONT SIZE=-1>";
    sResponse += "<p>POV bedeutet: Persistence of vision. Es nutzt die Tr&auml;gheit des Auges.</p>";
    sResponse += "<FONT SIZE=+1>";
	  sResponse += "<p>" + String(sVersion) + " vom " + String(sVersionDate) + "<BR>Attraktor e.V.</p>";
    sResponse += "<p>Gib in das Feld den neuen Anzeigetext ein und dr&uumlcke OK.<BR></p>";
    sResponse += "<FONT SIZE=+2>";
	  sResponse += "<form><label for='POVText'>Anzeigetext: ";
    sResponse += "<input type='text' id='POVText' name='POVText' value='' size='20'></label><br>";
    sResponse += "<FONT SIZE=+1>";
    sResponse += "<p>Erlaubte Zeichen: a-z A-Z . ! ? + # </p>";
    sResponse += "<FONT SIZE=+2>";
    sResponse += "<p><a href=\"?pin=OK\"><button>OK</button></a></p>";

	// Auf die Parameter reagieren ...
    if (sCmd.length()>0) {
      char POVText[sCmd.length() + 1];
      memset(POVText, 0, sCmd.length() + 1);
      int j = 0;
      boolean wrongChar = false;
      boolean specialChar = false;
      unsigned int specialChar2 = 0;
      for (uint i = 0; i < sCmd.length(); i++){
        switch (sCmd.charAt(i)) {
          case '%': 
            specialChar = true;
            break;
          case '2': 
            if ((specialChar == true) and (specialChar2 == 0)){
              specialChar2 = 2;
            }
            break;
          case '3': 
            if ((specialChar == true) and (specialChar2 == 0)){
              specialChar2 = 3;
            }
            else {
              if ((specialChar == true) and (specialChar2 == 2)){
                POVText[j] = '#';
                ++j;
                specialChar = false;
                specialChar2 = 0;
              }
              else {
                wrongChar = true;
                i = sCmd.length();
              }
            }
            break;
          case 'B': 
            if ((specialChar == true) and (specialChar2 == 2)){
              POVText[j] = '+';
              ++j;
            }
            else {
              POVText[j] = sCmd.charAt(i);
              ++j;
            }
            break;
          case '1': 
            if ((specialChar == true) and (specialChar2 == 2)){
              POVText[j] = '!';
              ++j;
            }
            else {
              wrongChar = true;
              i = sCmd.length();
            }
            break;
          case 'F': 
            if ((specialChar == true) and (specialChar2 == 3)){
              POVText[j] = '?';
              ++j;
            }
            else {
              POVText[j] = sCmd.charAt(i);
              ++j;
            }
            break;
          case '+':
            POVText[j] = ' ';
              ++j;
            break;
          default:
            POVText[j] = sCmd.charAt(i);
            ++j;
            break;
        }
      }
      if (wrongChar == true) {
        sAnzeigetext = "unzul%auml;ssiges Zeichen";
      }
      else {
        sAnzeigetext = POVText;
      }
      Serial.println(sAnzeigetext);
    }
    sResponse += "<FONT SIZE=+2>";
    sResponse += "<p>Aktueller Text: " + String(sAnzeigetext) + "</p>"; // schreibe aktuellen Anzeigetext auf html Seite
    sResponse += "<FONT SIZE=-2>";
    sResponse += "<BR>Aufrufz&auml;hler="; 
    sResponse += ulReqcount;
    sResponse += "<BR>";
    sResponse += "Attraktor e.V. 08/2018<BR>";
    sResponse += "</body></html>";
    
    sHeader  = "HTTP/1.1 200 OK\r\n";
    sHeader += "Content-Length: ";
    sHeader += sResponse.length();
    sHeader += "\r\n";
    sHeader += "Content-Type: text/html\r\n";
    sHeader += "Connection: close\r\n";
    sHeader += "\r\n";
  }
  
  // Send the response to the client
  client.print(sHeader);
  client.print(sResponse);
  delay(1000); // 1000 ms warten
  
  // and stop the client
  client.stop();
  Serial.println("Client disonnected");
}
